!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Program ArareInit
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: init.f90,v 1.3 2005/10/19 05:48:09 odakker Exp $ 
!   * Tag Name: $Name: arare3-20051019 $
!   * Change History: 
!
!== Overview 
!
!ϳإǥ deepconv/arare νͤ. 
!ͥեˤ 2 ƥåʬΥǡɬפʤΤ, 
!ǽ 1 ƥåפ򥪥顼ˡǷ׻
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!*ϤϽవ̷.
!
!== Future Plans
!
                                                                 !=end

program ArareInit
                                                                 !=begin
  !== Dependency
  use dc_trace,   only: BeginSub, EndSub, DbgMessage
  use dc_message
  use debugset,   only: debugset_init, DebugOn
  use gridset,    only: gridset_init, DimXMin, DimXMax, DimZMin, DimZMax, &
       &                RegZMin, RegZMax
  use fileset,    only: fileset_init, cfgfile, ReStartFile
  use timeset,    only: timeset_init, NstepShort, DelTimeLong, DelTimeShort
  use nameset,    only: nameset_init
  use physset,    only: physset_init  
  use linlib,     only: linlib_init
  use bcset,      only: bcset_init
  use arareset,   only: arareset_init
  use basicset,   only: basicset_calc_init
  use disturbset, only: disturbset_calc_init, &
       &                    ss_ExnerDisturb, ss_PotTempDisturb, &
       &                    fs_VelXDisturb,  sf_VelZDisturb
                                                                 !=end
  implicit none

  real(8), allocatable  :: ss_Exner_as(:,:)
  real(8), allocatable  :: fs_VelX_as(:,:)
  real(8), allocatable  :: sf_VelZ_as(:,:)
  real(8), allocatable  :: ss_Exner_ns(:,:)
  real(8), allocatable  :: fs_VelX_ns(:,:)
  real(8), allocatable  :: sf_VelZ_ns(:,:)

  real(8), allocatable  :: fs_AdvDiffX_nl(:,:)
  real(8), allocatable  :: sf_AdvDiffZ_nl(:,:)
  
  real(8), allocatable  :: fs_VelX_nl(:,:)
  real(8), allocatable  :: sf_VelZ_nl(:,:)
  real(8), allocatable  :: fs_VelX_al(:,:)
  real(8), allocatable  :: sf_VelZ_al(:,:)

  real(8), allocatable  :: ss_PotTemp_nl(:,:)
  real(8), allocatable  :: ss_Exner_nl(:,:)
  real(8), allocatable  :: ss_PotTemp_al(:,:)
  real(8), allocatable  :: ss_Exner_al(:,:)

  real(8), allocatable  :: ss_Km_al(:,:)
  real(8), allocatable  :: ss_Kh_al(:,:)
  real(8), allocatable  :: ss_Km_nl(:,:)
  real(8), allocatable  :: ss_Kh_nl(:,:)

  real(8)               :: ReStartTime(2)
  integer               :: tau


!!!
!!!
!!!
  !--- I/O ե̾ν
  call fileset_init

  !--- ǥХν
  call debugset_init(cfgfile)

  !--- ʻν
  call gridset_init(cfgfile)
  
  !--- ʬν
  call timeset_init(cfgfile)
  
  !--- ¸̾ν
  call nameset_init(cfgfile)
  
  !--- ʪ̤ν
  call physset_init(cfgfile)
  
  !--- ׻ɤ߹
  call arareset_init(cfgfile)

  !--- 
  call bcset_init(cfgfile)

  !--- ¸ɤ߹
  call basicset_calc_init(cfgfile)

  !--- ¸ɤ߹
  call disturbset_calc_init(cfgfile)
  
  !--- ׻饤֥ν. 
  !--- ϥ顼 z η׻ΰ礭
  call linlib_init(cfgfile, RegZMax - RegZMin)
  

!!!
!!!ѿν
!!!  
  !--- γ, 
  call ArareAlloc

  !--- ν
  ss_Exner_nl   = ss_ExnerDisturb
  ss_PotTemp_nl = ss_PotTempDisturb
  fs_VelX_nl    = fs_VelXDisturb
  sf_VelZ_nl    = sf_VelZDisturb
  

!!!
!!!ʬ. 1 ƥåʬ. 
!!!
  !--- Ǵ, Ȼη׻
  call EddyViscosity(                                     &
       & ss_Km_nl,                                        & !ͤϥ
       & DelTimeLong,                                     & 
       & fs_VelX_nl, sf_VelZ_nl, ss_Km_nl,                & !ή
       & fs_VelX_nl, sf_VelZ_nl, ss_PotTemp_nl, ss_Km_nl, & !, Ȼ, û
       & ss_Km_al, ss_Kh_al )

  !--- Ĺ֥ƥåפǤβ̤η׻
  call Scalar(                                  & 
       & ss_PotTemp_nl,                         &
       & DelTimeLong,                           &
       & fs_VelX_nl, sf_VelZ_nl, ss_PotTemp_nl, & !ή
       & ss_PotTemp_nl, ss_Kh_nl,               & !, ήȻ, Ǵ
       & ss_PotTemp_al )
  
  !--- Ĺ֥ƥåפǤ® u ΰή, Ȼ, Ǵ
  call AdvectDiffuseX(                     &
       & fs_VelX_nl, sf_VelZ_nl,           & !ή
       & fs_VelX_nl, sf_VelZ_nl, ss_Km_nl, & !ήȻ, Ǵ
       & fs_AdvDiffX_nl )

  !--- Ĺ֥ƥåפǤ® w ΰή, Ȼ, Ǵ
  call AdvectDiffuseZ(                          &
       & fs_VelX_nl, sf_VelZ_nl, ss_PotTemp_nl, & !ή, 
       & fs_VelX_nl, sf_VelZ_nl, ss_Km_nl,      & !ήȻ, Ǵ
       & sf_AdvDiffZ_nl )
  
  !--- ûॹƥåפνͤ
  fs_VelX_ns  = fs_VelX_nl
  sf_VelZ_ns  = sf_VelZ_nl
  ss_Exner_ns = ss_Exner_nl 
  
  !--- ûॹƥåפǤʬ
  do tau = 1, NstepShort / 2
     !--- ® u η׻
     call VelocityX(                                             &
          & fs_VelX_ns,                                          &
          & DelTimeShort,                                        &
          & fs_AdvDiffX_nl, fs_VelX_ns, sf_VelZ_ns, ss_Exner_ns, &
          & fs_VelX_as )
     
     !--- ʡؿη׻
     call Exner( &
          & sf_AdvDiffZ_nl, fs_VelX_ns, fs_VelX_as, sf_VelZ_ns, ss_Exner_ns, &
          & ss_Exner_as )
     
     !--- ® w η׻
     call VelocityZ(  &
          & sf_VelZ_nl, &
          & DelTimeShort,    &
          & sf_AdvDiffZ_nl, fs_VelX_ns, sf_VelZ_ns, ss_Exner_ns, ss_Exner_as, &
          & sf_VelZ_as )
     
     !--- 롼פ󤹤ν
     ss_Exner_ns  = ss_Exner_as 
     fs_VelX_ns   = fs_VelX_as
     sf_VelZ_ns   = sf_VelZ_as
  end do
     
  !--- ǽŪ®٤Ĺ֥ƥåפǤΤΤȤߤʤ
  ss_Exner_al  = ss_Exner_as 
  fs_VelX_al   = fs_VelX_as
  sf_VelZ_al   = sf_VelZ_as     

  !--- ե
  ReStartTime(1) = 0.0d0
  ReStartTime(2) = DelTimeLong
  call MakeReStartFile( ReStartFile, ReStartTime,  &
       & fs_VelX_nl,    sf_VelZ_nl,  ss_Exner_nl,  &
       & ss_PotTemp_nl, ss_Km_nl,    ss_Kh_nl,     &
       & fs_VelX_al,    sf_VelZ_al,  ss_Exner_al,  &
       & ss_PotTemp_al, ss_Km_al,    ss_Kh_al      ) 

contains


!!!
!!!γ, 
!!!
  subroutine ArareAlloc

    call BeginSub("ArareAlloc", &
&                 fmt="%c",     &
&                 c1="Allocate and initialize allocatable variables.")

    allocate(ss_Exner_as(DimXMin:DimXMax, DimZMin:DimZMax),  &
         & fs_VelX_as(DimXMin:DimXMax, DimZMin:DimZMax)  , &
         & sf_VelZ_as(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_ns(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_ns(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_ns(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_PotTemp_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_PotTemp_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_AdvDiffX_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_AdvDiffZ_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Km_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Kh_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Km_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Kh_nl(DimXMin:DimXMax, DimZMin:DimZMax) )

    fs_VelX_al = 0.0d0
    fs_VelX_nl = 0.0d0

    sf_VelZ_al = 0.0d0
    sf_VelZ_nl = 0.0d0

    ss_Exner_al = 0.0d0
    ss_Exner_nl = 0.0d0

    ss_PotTemp_al = 0.0d0
    ss_PotTemp_nl = 0.0d0

    fs_VelX_as = 0.0d0
    fs_VelX_ns = 0.0d0

    sf_VelZ_as = 0.0d0
    sf_VelZ_ns = 0.0d0

    ss_Exner_as = 0.0d0
    ss_Exner_ns = 0.0d0

    fs_AdvDiffX_nl = 0.0d0
    sf_AdvDiffZ_nl = 0.0d0

    ss_Km_nl = 0.0d0
    ss_Kh_nl = 0.0d0

    ss_Km_al = 0.0d0
    ss_Kh_al = 0.0d0

    call EndSub("ArareAlloc")

  end subroutine ArareAlloc


end program ArareInit
